// Programmierung Paralleler Prozesse, Wahlaufgabe 2.1
// Paralleles Mergesort
// slave3.c -- Slave-Programm
// Matthias Jauernig, Michael Lahl, 2005

#include <stdio.h>
#include <stdlib.h>
#include </usr/local/pvm3/include/pvm3.h>

void quicksort(int a[], int l, int r);
void merging(int *A, int r);

int main (void) {
  int *A, m; 
  int i, r, ppid, numt, *tids;

  ppid = pvm_parent();

  //Daten von Parent empfangen
  pvm_recv(ppid, 3);
  //auspacken der Daten
  pvm_upkint(&m, 1, 1); //noch zu oeffnende Slaves
  pvm_upkint(&r, 1, 1); //Laenge der uebergebenen Teilfolge
  A = (int*)malloc(r * sizeof(int));
  pvm_upkint(A, r, 1);  //zu sortierende Teilfolge
  
  tids = (int*)malloc(m * sizeof(int));
  numt = pvm_spawn( "slave3", (char**)0, 0, "", m, tids);
  if(numt < 0){
    printf("\nFehler in pvm_spawn (numt): %d", numt);
  }    
  for(i=0; i<numt; i++){
    if(tids[i]<0){
      printf("\nFehler in pvm_spawn (tid(%d)): %x", i, tids[i]);
    }    
  }
  
  //Teilfolgen an die Slaves senden
  for(i=numt-1; i>=0; i--) {
    pvm_initsend( PvmDataRaw );
    //Anzahl Slaves die noch vom empfangenen Slave geoeffnet werden muessen 
    pvm_pkint(&i, 1, 1);
    //Laenge der zu uebertragenden Folge berechnen
    r/=2;
    pvm_pkint(&r, 1, 1);
    //Folge einpacken
    pvm_pkint(&A[r], r, 1);
    //Paket senden
    pvm_send(tids[i], 3);
  }

  // eigene Teilfolge sortieren
  quicksort(A, 0, r-1);
  
  for(i=0; i<numt; i++) {
    //empfangen von Slave i
    pvm_recv(tids[i], 2);
    //Folge entpacken
    pvm_upkint(&A[r], r, 1);
    merging(A, r);
    r *= 2;
  }
  //Daten an Parent zurueck senden
  pvm_initsend( PvmDataRaw ); 
  pvm_pkint(&A[0], r, 1);
  pvm_send(ppid, 2);
  
  //Prozess beim PVMD abmelden
  pvm_exit();
  return 0;
}

void quicksort(int a[], int l, int r){		//a=Array, l=linker Rand, r=rechter Rand
    if(r>l){					//solange mehr als 1 Folgenelement existiert
        int i=l-1, j=r, tmp;			//Variableninitialisierung mit Folgenrndern
        for(;;){				//Endlosschleife; bricht ab, wenn i>=j
            while(a[++i]<a[r]);			//inkrem., bis greres  Element gefunden wird
            while(a[--j]>a[r] && j>i);		//dekrem., bis kleineres Element gefunden wird
            if(i>=j) break;			//brich ab, wenn sich die Folgenzeiger treffen
            tmp=a[i]; a[i]=a[j]; a[j]=tmp;	//tausche kleineres mit grerem Element
        }
        tmp=a[i]; a[i]=a[r]; a[r]=tmp;		//tausche Trennelement

        quicksort(a, l, i-1);			//rekursiver Aufruf fr linke Teilfolge
        quicksort(a, i+1, r);			//rekursiver Aufruf fr rechte Teilfolge
    }
}

// Mergen der beiden in A enthaltenen Teilfolgen
// r gibt dabei die Lnge einer Teilfolge an
void merging(int *A, int r){
  int i=0, j=0, k=0;
  //Hilfarray fuer resultierende Folge
  int *B = (int*)malloc(2*r * sizeof(int));
  //i = Zhler fr Folgenelemente in B
  //j = Laenge erste Folge; k = Laenge zweite Folge
  //beide Folgen innerhalb von A[]
  while(j<r || k<r){
    //(wenn Elem 2. Teilfolge grer Elem 1. Teilfolge
    //oder 2. Teilfolge leer) und 1. Teilfolge nicht leer
    // => speichere 1. Teilfolgenelement in B
    if((k>=r || A[j]<A[r+k]) && j<r){
      B[i++] = A[j++];
    }
    // => speichere 2. Teilfolgenelement in B sonst
    else{
      B[i++] = A[r+k++];
    }
  }
  //kopieren der gemergeten Folge aus B[] nach A[]
  memcpy(A, B, 2*r * sizeof(int));
  free(B);
}
